! file svd.f90

!==========================================================================

 MODULE svd

      INTEGER, PARAMETER :: SP = KIND(1.0)
      INTEGER, PARAMETER :: DP = KIND(1.0D0)
      INTEGER, PARAMETER :: LGT = KIND(.true.)
      INTEGER, PARAMETER :: NPAR_GEOP=4,NPAR2_GEOP=2
      INTEGER, PARAMETER :: NPAR_ARTH=16,NPAR2_ARTH=8


! APPARENTLY F2PY CRASHES HERE, BUTS THAT'S JUST RIGHT.

      INTERFACE assert_eq
            MODULE PROCEDURE assert_eq2,assert_eq3,assert_eq4,assert_eqn
      END INTERFACE

    CONTAINS
!-----------------------------------------------------------------------------
SUBROUTINE fit(x,y,a,b,chi2)

IMPLICIT NONE
REAL, dimension(:), intent(in) :: x,y
REAL, intent(out) :: a,b,chi2
INTEGER :: ndata
REAL :: ss,sx,sxoss,sy,st2
REAL, dimension(size(x)) :: t

ndata = size(x)
ss = real(ndata)
sx = sum(x)
sy = sum(y)
sxoss = sx/ss
t(:) = x(:)-sxoss
b = dot_product(t,y)
st2 = dot_product(t,t)
b = b/st2
a = (sy-sx*b)/ss
!siga = sqrt((1.+sx*sx/(ss*st2))/ss)
!sigb = sqrt(1./st2)
t(:) = y(:) - a-b*x(:)
chi2 = st2

END SUBROUTINE fit
!-----------------------------------------------------------------------------
     FUNCTION arth_r(first,increment,n)
     REAL, INTENT(IN) :: first,increment
     INTEGER, INTENT(IN) :: n
     REAL, DIMENSION(n) :: arth_r
     INTEGER :: k,k2
     REAL :: temp
     if (n > 0) arth_r(1)=first
     if (n <= NPAR_ARTH) then
          do k=2,n
               arth_r(k)=arth_r(k-1)+increment
          end do
     else
          do k=2,NPAR2_ARTH
               arth_r(k)=arth_r(k-1)+increment
          end do
          temp=increment*NPAR2_ARTH
          k=NPAR2_ARTH
          do
               if (k >= n) exit
               k2=k+k
               arth_r(k+1:min(k2,n))=temp+arth_r(1:min(k,n-k))
               temp=temp+temp
               k=k2
          end do
     end if
     END FUNCTION arth_r
!-----------------------------------------------------------------------------
      FUNCTION assert_eq2(n1,n2,string)
      CHARACTER(LEN=*), INTENT(IN) :: string
      INTEGER, INTENT(IN) :: n1,n2
      INTEGER :: assert_eq2
      if (n1 == n2) then
            assert_eq2=n1
      else
            write (*,*) 'nrerror: an assert_eq2 failed with this tag:', &
                  string
!           STOP 'program terminated by assert_eq2'
      end if
      END FUNCTION assert_eq2
!-----------------------------------------------------------------------------
      FUNCTION assert_eq3(n1,n2,n3,string)
      CHARACTER(LEN=*), INTENT(IN) :: string
      INTEGER, INTENT(IN) :: n1,n2,n3
      INTEGER :: assert_eq3
      if (n1 == n2 .and. n2 == n3) then
            assert_eq3=n1
      else
            write (*,*) 'nrerror: an assert_eq3 failed with this tag:', &
                  string
!            STOP 'program terminated by assert_eq3'
      end if
      END FUNCTION assert_eq3
!-----------------------------------------------------------------------------
      FUNCTION assert_eq4(n1,n2,n3,n4,string)
      CHARACTER(LEN=*), INTENT(IN) :: string
      INTEGER, INTENT(IN) :: n1,n2,n3,n4
      INTEGER :: assert_eq4
      if (n1 == n2 .and. n2 == n3 .and. n3 == n4) then
            assert_eq4=n1
      else
            write (*,*) 'nrerror: an assert_eq failed with this tag:', &
                  string
!            STOP 'program terminated by assert_eq4'
      end if
      END FUNCTION assert_eq4
!-----------------------------------------------------------------------------
      FUNCTION assert_eqn(nn,string)
      CHARACTER(LEN=*), INTENT(IN) :: string
      INTEGER, DIMENSION(:), INTENT(IN) :: nn
      INTEGER :: assert_eqn
      if (all(nn(2:) == nn(1))) then
            assert_eqn=nn(1)
      else
            write (*,*) 'nrerror: an assert_eqn failed with this tag:', &
                  string
!            STOP 'program terminated by assert_eqn'
      end if
      END FUNCTION assert_eqn
!-----------------------------------------------------------------------------
      SUBROUTINE nrerror(string)
      CHARACTER(LEN=*), INTENT(IN) :: string
      write (*,*) 'nrerror: ',string
      STOP 'program terminated by nrerror'
      END SUBROUTINE nrerror
!-----------------------------------------------------------------------------
        FUNCTION vabs(v)
        REAL, DIMENSION(:), INTENT(IN) :: v
        REAL :: vabs
        vabs=sqrt(dot_product(v,v))
        END FUNCTION vabs
!     FUNCTION outerprod(a,b,n,m)
!-----------------------------------------------------------------------------
      FUNCTION outerprod(a,b)
        REAL, DIMENSION(:), INTENT(IN) :: a,b
        REAL, DIMENSION(size(a),size(b)) :: outerprod
        outerprod = spread(a,dim=2,ncopies=size(b)) * &
             spread(b,dim=1,ncopies=size(a))
      END FUNCTION outerprod
!-------------------------------------------------------------
      FUNCTION pythag(a,b)
!      USE nrtype
      IMPLICIT NONE
      REAL, INTENT(IN) :: a,b
      REAL :: pythag
      REAL :: absa,absb
      absa=abs(a)
      absb=abs(b)
      if (absa > absb) then
            pythag=absa*sqrt(1.0_sp+(absb/absa)**2)
      else
            if (absb == 0.0) then
                  pythag=0.0
            else
                  pythag=absb*sqrt(1.0_sp+(absa/absb)**2)
            end if
      end if
      END FUNCTION pythag
!--------------------------------------------------------------------------
      SUBROUTINE svdfit(x,y,sig,a,v,w,chisq)
!     USE nrtype; USE nrutil, ONLY : assert_eq,vabs
!     USE nr, ONLY : svbksb,svdcmp
      IMPLICIT NONE
      REAL, DIMENSION(:), INTENT(IN) :: x,y,sig
      REAL, DIMENSION(:), INTENT(OUT) :: a,w
      REAL, DIMENSION(:,:), INTENT(OUT) :: v
      REAL, INTENT(OUT) :: chisq

      REAL, PARAMETER :: TOL=1.0e-5_sp
      INTEGER :: i,ma,n
      REAL, DIMENSION(size(x)) :: b,sigi
      REAL, DIMENSION(size(x),size(a)) :: u,usav
      n=assert_eq(size(x),size(y),size(sig),'svdfit: n')
      ma=assert_eq(size(a),size(v,1),size(v,2),size(w),'svdfit: ma')
      sigi=1.0_sp/sig
      b=y*sigi
      do i=1,n
            usav(i,:)=fpoly(x(i),ma)
      end do
      u=usav*spread(sigi,dim=2,ncopies=ma)
      usav=u
      call svdcmp(u,w,v)
      where (w < TOL*maxval(w)) w=0.0
      call svbksb(u,w,v,b,a)
      chisq=vabs(matmul(usav,a)-b)**2
      END SUBROUTINE svdfit
!-----------------------------------------------------------------------------
      FUNCTION fpoly(x,n)
        REAL, INTENT(IN) :: x
        INTEGER, INTENT(IN) :: n
        REAL, DIMENSION(n) :: fpoly
        fpoly = geop_r(1.,x,n)
      END FUNCTION fpoly
!-----------------------------------------------------------------------------
      FUNCTION geop_r(first,factor,n)
        REAL, INTENT(IN) :: first,factor
        INTEGER, INTENT(IN) :: n
        REAL, DIMENSION(n) :: geop_r
        INTEGER :: k,k2
        REAL :: temp
        if (n > 0) geop_r(1)=first
        if (n <= NPAR_GEOP) then
           do k=2,n
              geop_r(k)=geop_r(k-1)*factor
           end do
        else
           do k=2,NPAR2_GEOP
              geop_r(k)=geop_r(k-1)*factor
           end do
                temp=factor**NPAR2_GEOP
                k=NPAR2_GEOP
                do
                        if (k >= n) exit
                        k2=k+k
                        geop_r(k+1:min(k2,n))=temp*geop_r(1:min(k,n-k))
                        temp=temp*temp
                        k=k2
                end do
        end if
      END FUNCTION geop_r
!-----------------------------------------------------------------------------
      SUBROUTINE svbksb(u,w,v,b,x)
!      USE nrtype; USE nrutil, ONLY : assert_eq
      REAL, DIMENSION(:,:), INTENT(IN) :: u,v
      REAL, DIMENSION(:), INTENT(IN) :: w,b
      REAL, DIMENSION(:), INTENT(OUT) :: x
      INTEGER :: mdum,ndum
      REAL, DIMENSION(size(x)) :: tmp
      mdum=assert_eq(size(u,1),size(b),'svbksb_sp: mdum')
      ndum=assert_eq((/size(u,2),size(v,1),size(v,2),size(w),size(x)/),&
            'svbksb_sp: ndum')
      where (w /= 0.0)
            tmp=matmul(b,u)/w
      elsewhere
            tmp=0.0
      end where
      x=matmul(v,tmp)
      END SUBROUTINE svbksb
!----------------------------------------------------------------------
      SUBROUTINE svdcmp(a,w,v)
!      USE nrtype; USE nrutil, ONLY : assert_eq,nrerror,outerprod
!      USE nr, ONLY : pythag
      IMPLICIT NONE
      REAL, DIMENSION(:,:), INTENT(INOUT) :: a
      REAL, DIMENSION(:), INTENT(OUT) :: w
      REAL, DIMENSION(:,:), INTENT(OUT) :: v
      INTEGER :: i,its,j,k,l,m,n,nm
      REAL :: anorm,c,f,g,h,s,scale,x,y,z
      REAL, DIMENSION(size(a,1)) :: tempm
      REAL, DIMENSION(size(a,2)) :: rv1,tempn
      m=size(a,1)
      n=assert_eq(size(a,2),size(v,1),size(v,2),size(w),'svdcmp')
      g=0.0
      scale=0.0
      do i=1,n
            l=i+1
            rv1(i)=scale*g
            g=0.0
            scale=0.0
            if (i <= m) then
                  scale=sum(abs(a(i:m,i)))
                  if (scale /= 0.0) then
                        a(i:m,i)=a(i:m,i)/scale
                        s=dot_product(a(i:m,i),a(i:m,i))
                        f=a(i,i)
                        g=-sign(sqrt(s),f)
                        h=f*g-s
                        a(i,i)=f-g
                        tempn(l:n)=matmul(a(i:m,i),a(i:m,l:n))/h
                        a(i:m,l:n)=a(i:m,l:n)+outerprod(a(i:m,i),tempn(l:n))
                        a(i:m,i)=scale*a(i:m,i)
                  end if
            end if
            w(i)=scale*g
            g=0.0
            scale=0.0
            if ((i <= m) .and. (i /= n)) then
                  scale=sum(abs(a(i,l:n)))
                  if (scale /= 0.0) then
                        a(i,l:n)=a(i,l:n)/scale
                        s=dot_product(a(i,l:n),a(i,l:n))
                        f=a(i,l)
                        g=-sign(sqrt(s),f)
                        h=f*g-s
                        a(i,l)=f-g
                        rv1(l:n)=a(i,l:n)/h
                        tempm(l:m)=matmul(a(l:m,l:n),a(i,l:n))
                        a(l:m,l:n)=a(l:m,l:n)+outerprod(tempm(l:m),rv1(l:n))
                        a(i,l:n)=scale*a(i,l:n)
                  end if
            end if
      end do
      anorm=maxval(abs(w)+abs(rv1))
      do i=n,1,-1
            if (i < n) then
                  if (g /= 0.0) then
                        v(l:n,i)=(a(i,l:n)/a(i,l))/g
                        tempn(l:n)=matmul(a(i,l:n),v(l:n,l:n))
                        v(l:n,l:n)=v(l:n,l:n)+outerprod(v(l:n,i),tempn(l:n))
                  end if
                  v(i,l:n)=0.0
                  v(l:n,i)=0.0
            end if
            v(i,i)=1.0
            g=rv1(i)
            l=i
      end do
      do i=min(m,n),1,-1
            l=i+1
            g=w(i)
            a(i,l:n)=0.0
            if (g /= 0.0) then
                  g=1.0_sp/g
                  tempn(l:n)=(matmul(a(l:m,i),a(l:m,l:n))/a(i,i))*g
                  a(i:m,l:n)=a(i:m,l:n)+outerprod(a(i:m,i),tempn(l:n))
                  a(i:m,i)=a(i:m,i)*g
            else
                  a(i:m,i)=0.0
            end if
            a(i,i)=a(i,i)+1.0_sp
      end do
      do k=n,1,-1
            do its=1,30
                  do l=k,1,-1
                        nm=l-1
                        if ((abs(rv1(l))+anorm) == anorm) exit
                        if ((abs(w(nm))+anorm) == anorm) then
                              c=0.0
                              s=1.0
                              do i=l,k
                                    f=s*rv1(i)
                                    rv1(i)=c*rv1(i)
                                    if ((abs(f)+anorm) == anorm) exit
                                    g=w(i)
                                    h=pythag(f,g)
                                    w(i)=h
                                    h=1.0_sp/h
                                    c= (g*h)
                                    s=-(f*h)
                                    tempm(1:m)=a(1:m,nm)
                                    a(1:m,nm)=a(1:m,nm)*c+a(1:m,i)*s
                                    a(1:m,i)=-tempm(1:m)*s+a(1:m,i)*c
                              end do
                              exit
                        end if
                  end do
                  z=w(k)
                  if (l == k) then
                        if (z < 0.0) then
                              w(k)=-z
                              v(1:n,k)=-v(1:n,k)
                        end if
                        exit
                  end if
                  if (its == 30) call nrerror('svdcmp: no convergence in svdcmp')
                  x=w(l)
                  nm=k-1
                  y=w(nm)
                  g=rv1(nm)
                  h=rv1(k)
                  f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0_sp*h*y)
                  g=pythag(f,1.0_sp)
                  f=((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
                  c=1.0
                  s=1.0
                  do j=l,nm
                        i=j+1
                        g=rv1(i)
                        y=w(i)
                        h=s*g
                        g=c*g
                        z=pythag(f,h)
                        rv1(j)=z
                        c=f/z
                        s=h/z
                        f= (x*c)+(g*s)
                        g=-(x*s)+(g*c)
                        h=y*s
                        y=y*c
                        tempn(1:n)=v(1:n,j)
                        v(1:n,j)=v(1:n,j)*c+v(1:n,i)*s
                        v(1:n,i)=-tempn(1:n)*s+v(1:n,i)*c
                        z=pythag(f,h)
                        w(j)=z
                        if (z /= 0.0) then
                              z=1.0_sp/z
                              c=f*z
                              s=h*z
                        end if
                        f= (c*g)+(s*y)
                        x=-(s*g)+(c*y)
                        tempm(1:m)=a(1:m,j)
                        a(1:m,j)=a(1:m,j)*c+a(1:m,i)*s
                        a(1:m,i)=-tempm(1:m)*s+a(1:m,i)*c
                  end do
                  rv1(l)=0.0
                  rv1(k)=f
                  w(k)=x
            end do
      end do
      END SUBROUTINE svdcmp
!--------------------------------------------------------------------------
 END MODULE svd
